--[[
  * Mostly Harmless's [ Full Immersion ]
  * Sponsored & Supported by: Mostly Harmless (mostly-harmless-guild.com)
  * Author: Wykkyd, aka Wykkyd Gaming (wykkyd.gaming@gmail.com)
  * Special Thanks To: Zenimax Online Studios & Bethesda for The Elder Scrolls Online
]]--

mhFI = {}
mhFI.__index = mhFI
mhFI.AddonID = "mhFullImmersion"

local windows = {
	["ZO_Compass"] = "compass",
	["ZO_CompassFrame"] = "compass",
	["ZO_FocusedQuestTrackerPanel"] = "quest",
	["ZO_QuestTracker"] = "quest",
	["ZO_ReticleContainer"] = "reticle",
}

mhFI.UpdateWindowState = function()
	local on = mhFISettings["enabled"] or false
	if on then
		for w,g in pairs(windows) do
			if mhFISettings[g] then
				if _G[w] ~= nil then
					if not _G[w]:IsHidden() then _G[w]:SetHidden( true ) end
				end
			end
		end
	end
end

mhFI.Ready, mhFI.AddonName, mhFI.AddonAbbrev, mhFI.AddonVersion, mhFI.AddonDescr = FW_RegisterFactory( 
	mhFI.AddonID, 
	{
		AddonID = mhFI.AddonID,
		AddonName = "[MH] Full Immersion",
		AddonAbbrev = "mhFI",
		Author = "Wykkyd",
		AddonVersion = "1.14.3.3.1",
		StartUp = function() 
			fwMenu.AddHeader("Immersive Windows")
			fwMenu.AddCheckbox("Emable Immersive Window Hiding", nil, function() 
				return mhFISettings["enabled"] or false
			end, function(val)
				mhFISettings["enabled"] = val
			end)
			fwMenu.AddCheckbox("Hide Compass", nil, function() 
				return mhFISettings["compass"] or false
			end, function(val)
				mhFISettings["compass"] = val
			end)
			fwMenu.AddCheckbox("Hide Quest Tracker", nil, function() 
				return mhFISettings["quest"] or false
			end, function(val)
				mhFISettings["quest"] = val
			end)
			fwMenu.AddCheckbox("Hide Reticle", nil, function() 
				return mhFISettings["reticle"] or false
			end, function(val)
				mhFISettings["reticle"] = val
			end)
			FW_Tic( "mhFIWindowTic", mhFI.UpdateWindowState )
		end,
		SavedVariables = function()
			if mhFullImmersion == nil then mhFullImmersion = {} end
			mhFISettings = ZO_SavedVars:New("mhFullImmersion", 1, "Settings", {}, "WindowsToHide") or {}
		end,
	}
)